CR .( gforth compatibility and extensions )
CR .(   eForth and btc copyright Bill Muench 1990-2007 ) CR
\ ==============================================================
\ todo
\ ==============================================================
\ 20070715 bee DOES> bug  add +ORDER -ORDER
\ 20070709 bee add ' ['] for "Cannot tick compile-only word"
\ 20070419 bee separate from eforth load file
\          try to tame gforth error messages
\ 20070417 bee gforth try again grrr
\          grrr gforth  emeta.b:184: Cannot tick compile-only word
\ 20061210 bee start ctrl bug  logout on include error bug/feature
\ ==============================================================

DECIMAL

\ a quieter, tamer gforth
' noop is dobacktrace \ limit error messages ( *** )
' noop is bootmessage \ no signon message
' noop is .status     \ info after the 'ok' ( noop is default )

\ bug fixes gforth069   create c, does>   fails
: DOES> POSTPONE ALIGN POSTPONE DOES> ; IMMEDIATE

: CTRL ( 'c' -- c ) CHAR $01F AND ; \ gforth069  char $40 -
: [CTRL] ( 'c' -- ) CTRL [COMPILE] LITERAL ; IMMEDIATE

\ annoying 'features'  comp' needed for compile-only words
: ' ( "name" -- xt ) (') (name>x) DROP (cfa>int) ;
: ['] ( "name" -- ) ' POSTPONE LITERAL ; IMMEDIATE

: INCLUDED ( ca u -- ) \ prevent error logout
  ['] INCLUDED CATCH IF DOERROR QUIT THEN ;

\ swiftforth style search order
: _-ORDER ( w wid*n n -- wid*n w n ) ( remove from search order )
  DUP IF 1- SWAP >R   RECURSE   ( wid*n w n )
    OVER R@ XOR IF 1+ R> -ROT EXIT THEN R> DROP
  THEN ;
: -ORDER ( wid -- ) GET-ORDER  _-ORDER NIP  SET-ORDER ;
: +ORDER ( wid -- ) DUP >R -ORDER  GET-ORDER R> SWAP 1+ SET-ORDER ;

\ ==============================================================
\ : DEFERS ( compilation "name" -- ; run-time ... -- ... )
\   \G Compiles the present contents of the deferred word @i{name}
\   \G into the current definition.  I.e., this produces static
\   \G binding as if @i{name} was not deferred.
\   ' >BODY @ COMPILE, ; IMMEDIATE
\ ==============================================================

\ column output control
CREATE C#  0 , 64 , \ current column, max column
: _EMIT ( c -- )      1 C# +!   DEFERS EMIT ;   ' _EMIT IS EMIT
: _TYPE ( ca u -- ) DUP C# +!   DEFERS TYPE ;   ' _TYPE IS TYPE
: CR ( -- ) CR   0 C# ! ;
: ?CR ( u -- ) C# 2@ U< IF CR THEN ;

\ ==============================================================

