CR .( radix based number i/o ) CR
\ ==============================================================
\ todo     constants -1 0 1  macros
\ ==============================================================
\ 20070729 bee use abort" not throw
\ 20070720 bee separate
\ ==============================================================
DECIMAL

: rni ( n 'ccc' -- n | d ) \ radix number input
  BASE @ >R  BASE !   \ save and set radix
  PARSE-WORD          \ get ca u of string
  ['] EVALUATE CATCH  \ try to convert to number
  R> BASE !           \ restore radix before
  abort" number?" ;   \ error control
  : D# 10 rni ; IMMEDIATE     : B#  2 rni ; IMMEDIATE
  : H# 16 rni ; IMMEDIATE     : O#  8 rni ; IMMEDIATE

\ : [SAVE-ORDER] ( -- ) \ macro
\   S" GET-ORDER DUP BEGIN ?DUP WHILE 1- ROT >R REPEAT >R"
\   EVALUATE ; IMMEDIATE
\ 
\ : [RESTORE-ORDER] ( -- ) \ macro
\   S" R> DUP BEGIN ?DUP WHILE 1- R> -ROT REPEAT SET-ORDER"
\   EVALUATE ; IMMEDIATE
\ 
\ : rni ( n 'ccc' -- n | d )  \ radix number input
\   BASE @ >R  BASE !         \ save and set radix
\   [SAVE-ORDER] ONLY \ FORTH
\   PARSE-WORD                \ get ca u of string
\   ['] EVALUATE CATCH        \ try to convert to number
\   [RESTORE-ORDER]
\   R> BASE !                 \ restore radix before
\   abort" number?" ;         \ error control
\   : D# 10 rni ; IMMEDIATE     : B#  2 rni ; IMMEDIATE
\   : H# 16 rni ; IMMEDIATE     : O#  8 rni ; IMMEDIATE

: rno ( n n -- ) BASE @ >R BASE ! U. R> BASE ! ; \ radix number output
  : .D 10 rno ;   : .H 16 rno ;   : .B  2 rno ;   : .O  8 rno ;

