CR .( eForth WORDS with initial chars match ) CR
\ ==============================================================
\ todo
\ ==============================================================
\ 20070723 bee add for gforth
\ ==============================================================
DECIMAL

: UPPER ( c -- C ) \ convert to uppercase
  DUP [CHAR] a [ CHAR z  1+ ] LITERAL WITHIN IF BL XOR THEN ;

: SAME? ( a a u -- f ) \ compare strings
  SWAP >R
  BEGIN DUP
  WHILE 1-  2DUP + C@ UPPER  OVER R@ + C@ UPPER  XOR
  UNTIL R> DROP 2DROP  0 EXIT \ no match
  THEN R> DROP 2DROP  -1 ;    \ found

CREATE A_N  0 DUP , , \ match string pointer

: WID-WORDS ( wid -- )
  WORDLIST-ID
  BEGIN @ DUP  NUF? 0= AND
  WHILE DUP NAME>STRING  OVER A_N 2@ SAME?
    IF TYPE SPACE  ?CR
    ELSE 2DROP
    THEN
  REPEAT DROP ;

CREATE 'VOC  ' .VOC , \ .VOC execution vector

: _WORDS ( -- )
  NUF @ 0 NUF ! \ 0 throttle
  VOCLINK
  BEGIN @ DUP
  WHILE DUP 0 WORDLIST-LINK - ( wid ) >R
    CR S" __wordlist__ " TYPE  R@ 'VOC @ EXECUTE
    CR R> WID-WORDS
  REPEAT DROP  NUF ! ;
: WW ( -- ) 0 A_N !  _WORDS ;

: WORDS ( ['ccc'] -- )
  BL PARSE  2DUP A_N 2!
  IF _WORDS
  ELSE CR CONTEXT @ WID-WORDS
  THEN DROP ;
: W ( ['ccc'] -- ) WORDS ;

